// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package contracts

import (
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
)

// IRewardLockerVestingSchedule is an auto generated low-level Go binding around an user-defined struct.
type IRewardLockerVestingSchedule struct {
	StartBlock     uint64
	EndBlock       uint64
	Quantity       *big.Int
	VestedQuantity *big.Int
}

// RewardLockerABI is the input ABI used to generate the binding from.
const RewardLockerABI = "[{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"previousOwner\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"OwnershipTransferred\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"rewardContract\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"bool\",\"name\":\"isAdded\",\"type\":\"bool\"}],\"name\":\"RewardContractAdded\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint64\",\"name\":\"vestingDuration\",\"type\":\"uint64\"}],\"name\":\"SetVestingDuration\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"size\",\"type\":\"uint256\"}],\"name\":\"UpdateMaxContractSize\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"totalVesting\",\"type\":\"uint256\"}],\"name\":\"Vest\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"beneficiary\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"vestedQuantity\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"index\",\"type\":\"uint256\"}],\"name\":\"Vested\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"beneficiary\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"startBlock\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"endBlock\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"quantity\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"index\",\"type\":\"uint256\"}],\"name\":\"VestingEntryCreated\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"uint256\",\"name\":\"index\",\"type\":\"uint256\"},{\"indexed\":true,\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"beneficiary\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"quantity\",\"type\":\"uint256\"}],\"name\":\"VestingEntryQueued\",\"type\":\"event\"},{\"inputs\":[],\"name\":\"MAX_REWARD_CONTRACTS_SIZE\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"},{\"internalType\":\"contractIERC20\",\"name\":\"\",\"type\":\"address\"}],\"name\":\"accountEscrowedBalance\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"},{\"internalType\":\"contractIERC20\",\"name\":\"\",\"type\":\"address\"}],\"name\":\"accountVestedBalance\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"_rewardContract\",\"type\":\"address\"}],\"name\":\"addRewardsContract\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"}],\"name\":\"getRewardContractsPerToken\",\"outputs\":[{\"internalType\":\"address[]\",\"name\":\"rewardContracts\",\"type\":\"address[]\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"},{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"index\",\"type\":\"uint256\"}],\"name\":\"getVestingScheduleAtIndex\",\"outputs\":[{\"components\":[{\"internalType\":\"uint64\",\"name\":\"startBlock\",\"type\":\"uint64\"},{\"internalType\":\"uint64\",\"name\":\"endBlock\",\"type\":\"uint64\"},{\"internalType\":\"uint128\",\"name\":\"quantity\",\"type\":\"uint128\"},{\"internalType\":\"uint128\",\"name\":\"vestedQuantity\",\"type\":\"uint128\"}],\"internalType\":\"structIRewardLocker.VestingSchedule\",\"name\":\"\",\"type\":\"tuple\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"},{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"}],\"name\":\"getVestingSchedules\",\"outputs\":[{\"components\":[{\"internalType\":\"uint64\",\"name\":\"startBlock\",\"type\":\"uint64\"},{\"internalType\":\"uint64\",\"name\":\"endBlock\",\"type\":\"uint64\"},{\"internalType\":\"uint128\",\"name\":\"quantity\",\"type\":\"uint128\"},{\"internalType\":\"uint128\",\"name\":\"vestedQuantity\",\"type\":\"uint128\"}],\"internalType\":\"structIRewardLocker.VestingSchedule[]\",\"name\":\"schedules\",\"type\":\"tuple[]\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"quantity\",\"type\":\"uint256\"}],\"name\":\"lock\",\"outputs\":[],\"stateMutability\":\"payable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"quantity\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"startBlock\",\"type\":\"uint256\"}],\"name\":\"lockWithStartBlock\",\"outputs\":[],\"stateMutability\":\"payable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"},{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"}],\"name\":\"numVestingSchedules\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"owner\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"_rewardContract\",\"type\":\"address\"}],\"name\":\"removeRewardsContract\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"renounceOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"uint64\",\"name\":\"_vestingDuration\",\"type\":\"uint64\"}],\"name\":\"setVestingDuration\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"transferOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_size\",\"type\":\"uint256\"}],\"name\":\"updateMaxContractSize\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"}],\"name\":\"vestCompletedSchedules\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20[]\",\"name\":\"tokens\",\"type\":\"address[]\"}],\"name\":\"vestCompletedSchedulesForMultipleTokens\",\"outputs\":[{\"internalType\":\"uint256[]\",\"name\":\"vestedAmounts\",\"type\":\"uint256[]\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"uint256[]\",\"name\":\"indexes\",\"type\":\"uint256[]\"}],\"name\":\"vestScheduleAtIndices\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20[]\",\"name\":\"tokens\",\"type\":\"address[]\"},{\"internalType\":\"uint256[][]\",\"name\":\"indices\",\"type\":\"uint256[][]\"}],\"name\":\"vestScheduleForMultipleTokensAtIndices\",\"outputs\":[{\"internalType\":\"uint256[]\",\"name\":\"vestedAmounts\",\"type\":\"uint256[]\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"token\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"startIndex\",\"type\":\"uint256\"},{\"internalType\":\"uint256\",\"name\":\"endIndex\",\"type\":\"uint256\"}],\"name\":\"vestSchedulesInRange\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"\",\"type\":\"address\"}],\"name\":\"vestingDurationPerToken\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"}]"

// RewardLocker is an auto generated Go binding around an Ethereum contract.
type RewardLocker struct {
	RewardLockerCaller     // Read-only binding to the contract
	RewardLockerTransactor // Write-only binding to the contract
	RewardLockerFilterer   // Log filterer for contract events
}

// RewardLockerCaller is an auto generated read-only Go binding around an Ethereum contract.
type RewardLockerCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// RewardLockerTransactor is an auto generated write-only Go binding around an Ethereum contract.
type RewardLockerTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// RewardLockerFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type RewardLockerFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// RewardLockerSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type RewardLockerSession struct {
	Contract     *RewardLocker     // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// RewardLockerCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type RewardLockerCallerSession struct {
	Contract *RewardLockerCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts       // Call options to use throughout this session
}

// RewardLockerTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type RewardLockerTransactorSession struct {
	Contract     *RewardLockerTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts       // Transaction auth options to use throughout this session
}

// RewardLockerRaw is an auto generated low-level Go binding around an Ethereum contract.
type RewardLockerRaw struct {
	Contract *RewardLocker // Generic contract binding to access the raw methods on
}

// RewardLockerCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type RewardLockerCallerRaw struct {
	Contract *RewardLockerCaller // Generic read-only contract binding to access the raw methods on
}

// RewardLockerTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type RewardLockerTransactorRaw struct {
	Contract *RewardLockerTransactor // Generic write-only contract binding to access the raw methods on
}

// NewRewardLocker creates a new instance of RewardLocker, bound to a specific deployed contract.
func NewRewardLocker(address common.Address, backend bind.ContractBackend) (*RewardLocker, error) {
	contract, err := bindRewardLocker(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &RewardLocker{RewardLockerCaller: RewardLockerCaller{contract: contract}, RewardLockerTransactor: RewardLockerTransactor{contract: contract}, RewardLockerFilterer: RewardLockerFilterer{contract: contract}}, nil
}

// NewRewardLockerCaller creates a new read-only instance of RewardLocker, bound to a specific deployed contract.
func NewRewardLockerCaller(address common.Address, caller bind.ContractCaller) (*RewardLockerCaller, error) {
	contract, err := bindRewardLocker(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &RewardLockerCaller{contract: contract}, nil
}

// NewRewardLockerTransactor creates a new write-only instance of RewardLocker, bound to a specific deployed contract.
func NewRewardLockerTransactor(address common.Address, transactor bind.ContractTransactor) (*RewardLockerTransactor, error) {
	contract, err := bindRewardLocker(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &RewardLockerTransactor{contract: contract}, nil
}

// NewRewardLockerFilterer creates a new log filterer instance of RewardLocker, bound to a specific deployed contract.
func NewRewardLockerFilterer(address common.Address, filterer bind.ContractFilterer) (*RewardLockerFilterer, error) {
	contract, err := bindRewardLocker(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &RewardLockerFilterer{contract: contract}, nil
}

// bindRewardLocker binds a generic wrapper to an already deployed contract.
func bindRewardLocker(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := abi.JSON(strings.NewReader(RewardLockerABI))
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_RewardLocker *RewardLockerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _RewardLocker.Contract.RewardLockerCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_RewardLocker *RewardLockerRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _RewardLocker.Contract.RewardLockerTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_RewardLocker *RewardLockerRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _RewardLocker.Contract.RewardLockerTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_RewardLocker *RewardLockerCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _RewardLocker.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_RewardLocker *RewardLockerTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _RewardLocker.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_RewardLocker *RewardLockerTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _RewardLocker.Contract.contract.Transact(opts, method, params...)
}

// MAXREWARDCONTRACTSSIZE is a free data retrieval call binding the contract method 0xbe13849b.
//
// Solidity: function MAX_REWARD_CONTRACTS_SIZE() view returns(uint256)
func (_RewardLocker *RewardLockerCaller) MAXREWARDCONTRACTSSIZE(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _RewardLocker.contract.Call(opts, &out, "MAX_REWARD_CONTRACTS_SIZE")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// MAXREWARDCONTRACTSSIZE is a free data retrieval call binding the contract method 0xbe13849b.
//
// Solidity: function MAX_REWARD_CONTRACTS_SIZE() view returns(uint256)
func (_RewardLocker *RewardLockerSession) MAXREWARDCONTRACTSSIZE() (*big.Int, error) {
	return _RewardLocker.Contract.MAXREWARDCONTRACTSSIZE(&_RewardLocker.CallOpts)
}

// MAXREWARDCONTRACTSSIZE is a free data retrieval call binding the contract method 0xbe13849b.
//
// Solidity: function MAX_REWARD_CONTRACTS_SIZE() view returns(uint256)
func (_RewardLocker *RewardLockerCallerSession) MAXREWARDCONTRACTSSIZE() (*big.Int, error) {
	return _RewardLocker.Contract.MAXREWARDCONTRACTSSIZE(&_RewardLocker.CallOpts)
}

// AccountEscrowedBalance is a free data retrieval call binding the contract method 0x6e732b70.
//
// Solidity: function accountEscrowedBalance(address , address ) view returns(uint256)
func (_RewardLocker *RewardLockerCaller) AccountEscrowedBalance(opts *bind.CallOpts, arg0 common.Address, arg1 common.Address) (*big.Int, error) {
	var out []interface{}
	err := _RewardLocker.contract.Call(opts, &out, "accountEscrowedBalance", arg0, arg1)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// AccountEscrowedBalance is a free data retrieval call binding the contract method 0x6e732b70.
//
// Solidity: function accountEscrowedBalance(address , address ) view returns(uint256)
func (_RewardLocker *RewardLockerSession) AccountEscrowedBalance(arg0 common.Address, arg1 common.Address) (*big.Int, error) {
	return _RewardLocker.Contract.AccountEscrowedBalance(&_RewardLocker.CallOpts, arg0, arg1)
}

// AccountEscrowedBalance is a free data retrieval call binding the contract method 0x6e732b70.
//
// Solidity: function accountEscrowedBalance(address , address ) view returns(uint256)
func (_RewardLocker *RewardLockerCallerSession) AccountEscrowedBalance(arg0 common.Address, arg1 common.Address) (*big.Int, error) {
	return _RewardLocker.Contract.AccountEscrowedBalance(&_RewardLocker.CallOpts, arg0, arg1)
}

// AccountVestedBalance is a free data retrieval call binding the contract method 0x3b5bfa8b.
//
// Solidity: function accountVestedBalance(address , address ) view returns(uint256)
func (_RewardLocker *RewardLockerCaller) AccountVestedBalance(opts *bind.CallOpts, arg0 common.Address, arg1 common.Address) (*big.Int, error) {
	var out []interface{}
	err := _RewardLocker.contract.Call(opts, &out, "accountVestedBalance", arg0, arg1)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// AccountVestedBalance is a free data retrieval call binding the contract method 0x3b5bfa8b.
//
// Solidity: function accountVestedBalance(address , address ) view returns(uint256)
func (_RewardLocker *RewardLockerSession) AccountVestedBalance(arg0 common.Address, arg1 common.Address) (*big.Int, error) {
	return _RewardLocker.Contract.AccountVestedBalance(&_RewardLocker.CallOpts, arg0, arg1)
}

// AccountVestedBalance is a free data retrieval call binding the contract method 0x3b5bfa8b.
//
// Solidity: function accountVestedBalance(address , address ) view returns(uint256)
func (_RewardLocker *RewardLockerCallerSession) AccountVestedBalance(arg0 common.Address, arg1 common.Address) (*big.Int, error) {
	return _RewardLocker.Contract.AccountVestedBalance(&_RewardLocker.CallOpts, arg0, arg1)
}

// GetRewardContractsPerToken is a free data retrieval call binding the contract method 0xbbd8a328.
//
// Solidity: function getRewardContractsPerToken(address token) view returns(address[] rewardContracts)
func (_RewardLocker *RewardLockerCaller) GetRewardContractsPerToken(opts *bind.CallOpts, token common.Address) ([]common.Address, error) {
	var out []interface{}
	err := _RewardLocker.contract.Call(opts, &out, "getRewardContractsPerToken", token)

	if err != nil {
		return *new([]common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new([]common.Address)).(*[]common.Address)

	return out0, err

}

// GetRewardContractsPerToken is a free data retrieval call binding the contract method 0xbbd8a328.
//
// Solidity: function getRewardContractsPerToken(address token) view returns(address[] rewardContracts)
func (_RewardLocker *RewardLockerSession) GetRewardContractsPerToken(token common.Address) ([]common.Address, error) {
	return _RewardLocker.Contract.GetRewardContractsPerToken(&_RewardLocker.CallOpts, token)
}

// GetRewardContractsPerToken is a free data retrieval call binding the contract method 0xbbd8a328.
//
// Solidity: function getRewardContractsPerToken(address token) view returns(address[] rewardContracts)
func (_RewardLocker *RewardLockerCallerSession) GetRewardContractsPerToken(token common.Address) ([]common.Address, error) {
	return _RewardLocker.Contract.GetRewardContractsPerToken(&_RewardLocker.CallOpts, token)
}

// GetVestingScheduleAtIndex is a free data retrieval call binding the contract method 0x0a3b7e31.
//
// Solidity: function getVestingScheduleAtIndex(address account, address token, uint256 index) view returns((uint64,uint64,uint128,uint128))
func (_RewardLocker *RewardLockerCaller) GetVestingScheduleAtIndex(opts *bind.CallOpts, account common.Address, token common.Address, index *big.Int) (IRewardLockerVestingSchedule, error) {
	var out []interface{}
	err := _RewardLocker.contract.Call(opts, &out, "getVestingScheduleAtIndex", account, token, index)

	if err != nil {
		return *new(IRewardLockerVestingSchedule), err
	}

	out0 := *abi.ConvertType(out[0], new(IRewardLockerVestingSchedule)).(*IRewardLockerVestingSchedule)

	return out0, err

}

// GetVestingScheduleAtIndex is a free data retrieval call binding the contract method 0x0a3b7e31.
//
// Solidity: function getVestingScheduleAtIndex(address account, address token, uint256 index) view returns((uint64,uint64,uint128,uint128))
func (_RewardLocker *RewardLockerSession) GetVestingScheduleAtIndex(account common.Address, token common.Address, index *big.Int) (IRewardLockerVestingSchedule, error) {
	return _RewardLocker.Contract.GetVestingScheduleAtIndex(&_RewardLocker.CallOpts, account, token, index)
}

// GetVestingScheduleAtIndex is a free data retrieval call binding the contract method 0x0a3b7e31.
//
// Solidity: function getVestingScheduleAtIndex(address account, address token, uint256 index) view returns((uint64,uint64,uint128,uint128))
func (_RewardLocker *RewardLockerCallerSession) GetVestingScheduleAtIndex(account common.Address, token common.Address, index *big.Int) (IRewardLockerVestingSchedule, error) {
	return _RewardLocker.Contract.GetVestingScheduleAtIndex(&_RewardLocker.CallOpts, account, token, index)
}

// GetVestingSchedules is a free data retrieval call binding the contract method 0x2f50bd72.
//
// Solidity: function getVestingSchedules(address account, address token) view returns((uint64,uint64,uint128,uint128)[] schedules)
func (_RewardLocker *RewardLockerCaller) GetVestingSchedules(opts *bind.CallOpts, account common.Address, token common.Address) ([]IRewardLockerVestingSchedule, error) {
	var out []interface{}
	err := _RewardLocker.contract.Call(opts, &out, "getVestingSchedules", account, token)

	if err != nil {
		return *new([]IRewardLockerVestingSchedule), err
	}

	out0 := *abi.ConvertType(out[0], new([]IRewardLockerVestingSchedule)).(*[]IRewardLockerVestingSchedule)

	return out0, err

}

// GetVestingSchedules is a free data retrieval call binding the contract method 0x2f50bd72.
//
// Solidity: function getVestingSchedules(address account, address token) view returns((uint64,uint64,uint128,uint128)[] schedules)
func (_RewardLocker *RewardLockerSession) GetVestingSchedules(account common.Address, token common.Address) ([]IRewardLockerVestingSchedule, error) {
	return _RewardLocker.Contract.GetVestingSchedules(&_RewardLocker.CallOpts, account, token)
}

// GetVestingSchedules is a free data retrieval call binding the contract method 0x2f50bd72.
//
// Solidity: function getVestingSchedules(address account, address token) view returns((uint64,uint64,uint128,uint128)[] schedules)
func (_RewardLocker *RewardLockerCallerSession) GetVestingSchedules(account common.Address, token common.Address) ([]IRewardLockerVestingSchedule, error) {
	return _RewardLocker.Contract.GetVestingSchedules(&_RewardLocker.CallOpts, account, token)
}

// NumVestingSchedules is a free data retrieval call binding the contract method 0x679f7f77.
//
// Solidity: function numVestingSchedules(address account, address token) view returns(uint256)
func (_RewardLocker *RewardLockerCaller) NumVestingSchedules(opts *bind.CallOpts, account common.Address, token common.Address) (*big.Int, error) {
	var out []interface{}
	err := _RewardLocker.contract.Call(opts, &out, "numVestingSchedules", account, token)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// NumVestingSchedules is a free data retrieval call binding the contract method 0x679f7f77.
//
// Solidity: function numVestingSchedules(address account, address token) view returns(uint256)
func (_RewardLocker *RewardLockerSession) NumVestingSchedules(account common.Address, token common.Address) (*big.Int, error) {
	return _RewardLocker.Contract.NumVestingSchedules(&_RewardLocker.CallOpts, account, token)
}

// NumVestingSchedules is a free data retrieval call binding the contract method 0x679f7f77.
//
// Solidity: function numVestingSchedules(address account, address token) view returns(uint256)
func (_RewardLocker *RewardLockerCallerSession) NumVestingSchedules(account common.Address, token common.Address) (*big.Int, error) {
	return _RewardLocker.Contract.NumVestingSchedules(&_RewardLocker.CallOpts, account, token)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_RewardLocker *RewardLockerCaller) Owner(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _RewardLocker.contract.Call(opts, &out, "owner")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_RewardLocker *RewardLockerSession) Owner() (common.Address, error) {
	return _RewardLocker.Contract.Owner(&_RewardLocker.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_RewardLocker *RewardLockerCallerSession) Owner() (common.Address, error) {
	return _RewardLocker.Contract.Owner(&_RewardLocker.CallOpts)
}

// VestingDurationPerToken is a free data retrieval call binding the contract method 0xaaf54385.
//
// Solidity: function vestingDurationPerToken(address ) view returns(uint256)
func (_RewardLocker *RewardLockerCaller) VestingDurationPerToken(opts *bind.CallOpts, arg0 common.Address) (*big.Int, error) {
	var out []interface{}
	err := _RewardLocker.contract.Call(opts, &out, "vestingDurationPerToken", arg0)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// VestingDurationPerToken is a free data retrieval call binding the contract method 0xaaf54385.
//
// Solidity: function vestingDurationPerToken(address ) view returns(uint256)
func (_RewardLocker *RewardLockerSession) VestingDurationPerToken(arg0 common.Address) (*big.Int, error) {
	return _RewardLocker.Contract.VestingDurationPerToken(&_RewardLocker.CallOpts, arg0)
}

// VestingDurationPerToken is a free data retrieval call binding the contract method 0xaaf54385.
//
// Solidity: function vestingDurationPerToken(address ) view returns(uint256)
func (_RewardLocker *RewardLockerCallerSession) VestingDurationPerToken(arg0 common.Address) (*big.Int, error) {
	return _RewardLocker.Contract.VestingDurationPerToken(&_RewardLocker.CallOpts, arg0)
}

// AddRewardsContract is a paid mutator transaction binding the contract method 0xf793d77e.
//
// Solidity: function addRewardsContract(address token, address _rewardContract) returns()
func (_RewardLocker *RewardLockerTransactor) AddRewardsContract(opts *bind.TransactOpts, token common.Address, _rewardContract common.Address) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "addRewardsContract", token, _rewardContract)
}

// AddRewardsContract is a paid mutator transaction binding the contract method 0xf793d77e.
//
// Solidity: function addRewardsContract(address token, address _rewardContract) returns()
func (_RewardLocker *RewardLockerSession) AddRewardsContract(token common.Address, _rewardContract common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.AddRewardsContract(&_RewardLocker.TransactOpts, token, _rewardContract)
}

// AddRewardsContract is a paid mutator transaction binding the contract method 0xf793d77e.
//
// Solidity: function addRewardsContract(address token, address _rewardContract) returns()
func (_RewardLocker *RewardLockerTransactorSession) AddRewardsContract(token common.Address, _rewardContract common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.AddRewardsContract(&_RewardLocker.TransactOpts, token, _rewardContract)
}

// Lock is a paid mutator transaction binding the contract method 0x7750c9f0.
//
// Solidity: function lock(address token, address account, uint256 quantity) payable returns()
func (_RewardLocker *RewardLockerTransactor) Lock(opts *bind.TransactOpts, token common.Address, account common.Address, quantity *big.Int) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "lock", token, account, quantity)
}

// Lock is a paid mutator transaction binding the contract method 0x7750c9f0.
//
// Solidity: function lock(address token, address account, uint256 quantity) payable returns()
func (_RewardLocker *RewardLockerSession) Lock(token common.Address, account common.Address, quantity *big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.Lock(&_RewardLocker.TransactOpts, token, account, quantity)
}

// Lock is a paid mutator transaction binding the contract method 0x7750c9f0.
//
// Solidity: function lock(address token, address account, uint256 quantity) payable returns()
func (_RewardLocker *RewardLockerTransactorSession) Lock(token common.Address, account common.Address, quantity *big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.Lock(&_RewardLocker.TransactOpts, token, account, quantity)
}

// LockWithStartBlock is a paid mutator transaction binding the contract method 0xa5d21e31.
//
// Solidity: function lockWithStartBlock(address token, address account, uint256 quantity, uint256 startBlock) payable returns()
func (_RewardLocker *RewardLockerTransactor) LockWithStartBlock(opts *bind.TransactOpts, token common.Address, account common.Address, quantity *big.Int, startBlock *big.Int) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "lockWithStartBlock", token, account, quantity, startBlock)
}

// LockWithStartBlock is a paid mutator transaction binding the contract method 0xa5d21e31.
//
// Solidity: function lockWithStartBlock(address token, address account, uint256 quantity, uint256 startBlock) payable returns()
func (_RewardLocker *RewardLockerSession) LockWithStartBlock(token common.Address, account common.Address, quantity *big.Int, startBlock *big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.LockWithStartBlock(&_RewardLocker.TransactOpts, token, account, quantity, startBlock)
}

// LockWithStartBlock is a paid mutator transaction binding the contract method 0xa5d21e31.
//
// Solidity: function lockWithStartBlock(address token, address account, uint256 quantity, uint256 startBlock) payable returns()
func (_RewardLocker *RewardLockerTransactorSession) LockWithStartBlock(token common.Address, account common.Address, quantity *big.Int, startBlock *big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.LockWithStartBlock(&_RewardLocker.TransactOpts, token, account, quantity, startBlock)
}

// RemoveRewardsContract is a paid mutator transaction binding the contract method 0x4c9d00cc.
//
// Solidity: function removeRewardsContract(address token, address _rewardContract) returns()
func (_RewardLocker *RewardLockerTransactor) RemoveRewardsContract(opts *bind.TransactOpts, token common.Address, _rewardContract common.Address) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "removeRewardsContract", token, _rewardContract)
}

// RemoveRewardsContract is a paid mutator transaction binding the contract method 0x4c9d00cc.
//
// Solidity: function removeRewardsContract(address token, address _rewardContract) returns()
func (_RewardLocker *RewardLockerSession) RemoveRewardsContract(token common.Address, _rewardContract common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.RemoveRewardsContract(&_RewardLocker.TransactOpts, token, _rewardContract)
}

// RemoveRewardsContract is a paid mutator transaction binding the contract method 0x4c9d00cc.
//
// Solidity: function removeRewardsContract(address token, address _rewardContract) returns()
func (_RewardLocker *RewardLockerTransactorSession) RemoveRewardsContract(token common.Address, _rewardContract common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.RemoveRewardsContract(&_RewardLocker.TransactOpts, token, _rewardContract)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_RewardLocker *RewardLockerTransactor) RenounceOwnership(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "renounceOwnership")
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_RewardLocker *RewardLockerSession) RenounceOwnership() (*types.Transaction, error) {
	return _RewardLocker.Contract.RenounceOwnership(&_RewardLocker.TransactOpts)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_RewardLocker *RewardLockerTransactorSession) RenounceOwnership() (*types.Transaction, error) {
	return _RewardLocker.Contract.RenounceOwnership(&_RewardLocker.TransactOpts)
}

// SetVestingDuration is a paid mutator transaction binding the contract method 0xcb1d086b.
//
// Solidity: function setVestingDuration(address token, uint64 _vestingDuration) returns()
func (_RewardLocker *RewardLockerTransactor) SetVestingDuration(opts *bind.TransactOpts, token common.Address, _vestingDuration uint64) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "setVestingDuration", token, _vestingDuration)
}

// SetVestingDuration is a paid mutator transaction binding the contract method 0xcb1d086b.
//
// Solidity: function setVestingDuration(address token, uint64 _vestingDuration) returns()
func (_RewardLocker *RewardLockerSession) SetVestingDuration(token common.Address, _vestingDuration uint64) (*types.Transaction, error) {
	return _RewardLocker.Contract.SetVestingDuration(&_RewardLocker.TransactOpts, token, _vestingDuration)
}

// SetVestingDuration is a paid mutator transaction binding the contract method 0xcb1d086b.
//
// Solidity: function setVestingDuration(address token, uint64 _vestingDuration) returns()
func (_RewardLocker *RewardLockerTransactorSession) SetVestingDuration(token common.Address, _vestingDuration uint64) (*types.Transaction, error) {
	return _RewardLocker.Contract.SetVestingDuration(&_RewardLocker.TransactOpts, token, _vestingDuration)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_RewardLocker *RewardLockerTransactor) TransferOwnership(opts *bind.TransactOpts, newOwner common.Address) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "transferOwnership", newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_RewardLocker *RewardLockerSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.TransferOwnership(&_RewardLocker.TransactOpts, newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_RewardLocker *RewardLockerTransactorSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.TransferOwnership(&_RewardLocker.TransactOpts, newOwner)
}

// UpdateMaxContractSize is a paid mutator transaction binding the contract method 0x23179766.
//
// Solidity: function updateMaxContractSize(uint256 _size) returns()
func (_RewardLocker *RewardLockerTransactor) UpdateMaxContractSize(opts *bind.TransactOpts, _size *big.Int) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "updateMaxContractSize", _size)
}

// UpdateMaxContractSize is a paid mutator transaction binding the contract method 0x23179766.
//
// Solidity: function updateMaxContractSize(uint256 _size) returns()
func (_RewardLocker *RewardLockerSession) UpdateMaxContractSize(_size *big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.UpdateMaxContractSize(&_RewardLocker.TransactOpts, _size)
}

// UpdateMaxContractSize is a paid mutator transaction binding the contract method 0x23179766.
//
// Solidity: function updateMaxContractSize(uint256 _size) returns()
func (_RewardLocker *RewardLockerTransactorSession) UpdateMaxContractSize(_size *big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.UpdateMaxContractSize(&_RewardLocker.TransactOpts, _size)
}

// VestCompletedSchedules is a paid mutator transaction binding the contract method 0xfdfaaa05.
//
// Solidity: function vestCompletedSchedules(address token) returns(uint256)
func (_RewardLocker *RewardLockerTransactor) VestCompletedSchedules(opts *bind.TransactOpts, token common.Address) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "vestCompletedSchedules", token)
}

// VestCompletedSchedules is a paid mutator transaction binding the contract method 0xfdfaaa05.
//
// Solidity: function vestCompletedSchedules(address token) returns(uint256)
func (_RewardLocker *RewardLockerSession) VestCompletedSchedules(token common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestCompletedSchedules(&_RewardLocker.TransactOpts, token)
}

// VestCompletedSchedules is a paid mutator transaction binding the contract method 0xfdfaaa05.
//
// Solidity: function vestCompletedSchedules(address token) returns(uint256)
func (_RewardLocker *RewardLockerTransactorSession) VestCompletedSchedules(token common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestCompletedSchedules(&_RewardLocker.TransactOpts, token)
}

// VestCompletedSchedulesForMultipleTokens is a paid mutator transaction binding the contract method 0x9059aa6a.
//
// Solidity: function vestCompletedSchedulesForMultipleTokens(address[] tokens) returns(uint256[] vestedAmounts)
func (_RewardLocker *RewardLockerTransactor) VestCompletedSchedulesForMultipleTokens(opts *bind.TransactOpts, tokens []common.Address) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "vestCompletedSchedulesForMultipleTokens", tokens)
}

// VestCompletedSchedulesForMultipleTokens is a paid mutator transaction binding the contract method 0x9059aa6a.
//
// Solidity: function vestCompletedSchedulesForMultipleTokens(address[] tokens) returns(uint256[] vestedAmounts)
func (_RewardLocker *RewardLockerSession) VestCompletedSchedulesForMultipleTokens(tokens []common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestCompletedSchedulesForMultipleTokens(&_RewardLocker.TransactOpts, tokens)
}

// VestCompletedSchedulesForMultipleTokens is a paid mutator transaction binding the contract method 0x9059aa6a.
//
// Solidity: function vestCompletedSchedulesForMultipleTokens(address[] tokens) returns(uint256[] vestedAmounts)
func (_RewardLocker *RewardLockerTransactorSession) VestCompletedSchedulesForMultipleTokens(tokens []common.Address) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestCompletedSchedulesForMultipleTokens(&_RewardLocker.TransactOpts, tokens)
}

// VestScheduleAtIndices is a paid mutator transaction binding the contract method 0x0f5636c3.
//
// Solidity: function vestScheduleAtIndices(address token, uint256[] indexes) returns(uint256)
func (_RewardLocker *RewardLockerTransactor) VestScheduleAtIndices(opts *bind.TransactOpts, token common.Address, indexes []*big.Int) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "vestScheduleAtIndices", token, indexes)
}

// VestScheduleAtIndices is a paid mutator transaction binding the contract method 0x0f5636c3.
//
// Solidity: function vestScheduleAtIndices(address token, uint256[] indexes) returns(uint256)
func (_RewardLocker *RewardLockerSession) VestScheduleAtIndices(token common.Address, indexes []*big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestScheduleAtIndices(&_RewardLocker.TransactOpts, token, indexes)
}

// VestScheduleAtIndices is a paid mutator transaction binding the contract method 0x0f5636c3.
//
// Solidity: function vestScheduleAtIndices(address token, uint256[] indexes) returns(uint256)
func (_RewardLocker *RewardLockerTransactorSession) VestScheduleAtIndices(token common.Address, indexes []*big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestScheduleAtIndices(&_RewardLocker.TransactOpts, token, indexes)
}

// VestScheduleForMultipleTokensAtIndices is a paid mutator transaction binding the contract method 0x4d4f3d93.
//
// Solidity: function vestScheduleForMultipleTokensAtIndices(address[] tokens, uint256[][] indices) returns(uint256[] vestedAmounts)
func (_RewardLocker *RewardLockerTransactor) VestScheduleForMultipleTokensAtIndices(opts *bind.TransactOpts, tokens []common.Address, indices [][]*big.Int) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "vestScheduleForMultipleTokensAtIndices", tokens, indices)
}

// VestScheduleForMultipleTokensAtIndices is a paid mutator transaction binding the contract method 0x4d4f3d93.
//
// Solidity: function vestScheduleForMultipleTokensAtIndices(address[] tokens, uint256[][] indices) returns(uint256[] vestedAmounts)
func (_RewardLocker *RewardLockerSession) VestScheduleForMultipleTokensAtIndices(tokens []common.Address, indices [][]*big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestScheduleForMultipleTokensAtIndices(&_RewardLocker.TransactOpts, tokens, indices)
}

// VestScheduleForMultipleTokensAtIndices is a paid mutator transaction binding the contract method 0x4d4f3d93.
//
// Solidity: function vestScheduleForMultipleTokensAtIndices(address[] tokens, uint256[][] indices) returns(uint256[] vestedAmounts)
func (_RewardLocker *RewardLockerTransactorSession) VestScheduleForMultipleTokensAtIndices(tokens []common.Address, indices [][]*big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestScheduleForMultipleTokensAtIndices(&_RewardLocker.TransactOpts, tokens, indices)
}

// VestSchedulesInRange is a paid mutator transaction binding the contract method 0xc33fddf8.
//
// Solidity: function vestSchedulesInRange(address token, uint256 startIndex, uint256 endIndex) returns(uint256)
func (_RewardLocker *RewardLockerTransactor) VestSchedulesInRange(opts *bind.TransactOpts, token common.Address, startIndex *big.Int, endIndex *big.Int) (*types.Transaction, error) {
	return _RewardLocker.contract.Transact(opts, "vestSchedulesInRange", token, startIndex, endIndex)
}

// VestSchedulesInRange is a paid mutator transaction binding the contract method 0xc33fddf8.
//
// Solidity: function vestSchedulesInRange(address token, uint256 startIndex, uint256 endIndex) returns(uint256)
func (_RewardLocker *RewardLockerSession) VestSchedulesInRange(token common.Address, startIndex *big.Int, endIndex *big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestSchedulesInRange(&_RewardLocker.TransactOpts, token, startIndex, endIndex)
}

// VestSchedulesInRange is a paid mutator transaction binding the contract method 0xc33fddf8.
//
// Solidity: function vestSchedulesInRange(address token, uint256 startIndex, uint256 endIndex) returns(uint256)
func (_RewardLocker *RewardLockerTransactorSession) VestSchedulesInRange(token common.Address, startIndex *big.Int, endIndex *big.Int) (*types.Transaction, error) {
	return _RewardLocker.Contract.VestSchedulesInRange(&_RewardLocker.TransactOpts, token, startIndex, endIndex)
}

// RewardLockerOwnershipTransferredIterator is returned from FilterOwnershipTransferred and is used to iterate over the raw logs and unpacked data for OwnershipTransferred events raised by the RewardLocker contract.
type RewardLockerOwnershipTransferredIterator struct {
	Event *RewardLockerOwnershipTransferred // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *RewardLockerOwnershipTransferredIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(RewardLockerOwnershipTransferred)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(RewardLockerOwnershipTransferred)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *RewardLockerOwnershipTransferredIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *RewardLockerOwnershipTransferredIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// RewardLockerOwnershipTransferred represents a OwnershipTransferred event raised by the RewardLocker contract.
type RewardLockerOwnershipTransferred struct {
	PreviousOwner common.Address
	NewOwner      common.Address
	Raw           types.Log // Blockchain specific contextual infos
}

// FilterOwnershipTransferred is a free log retrieval operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_RewardLocker *RewardLockerFilterer) FilterOwnershipTransferred(opts *bind.FilterOpts, previousOwner []common.Address, newOwner []common.Address) (*RewardLockerOwnershipTransferredIterator, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _RewardLocker.contract.FilterLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return &RewardLockerOwnershipTransferredIterator{contract: _RewardLocker.contract, event: "OwnershipTransferred", logs: logs, sub: sub}, nil
}

// WatchOwnershipTransferred is a free log subscription operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_RewardLocker *RewardLockerFilterer) WatchOwnershipTransferred(opts *bind.WatchOpts, sink chan<- *RewardLockerOwnershipTransferred, previousOwner []common.Address, newOwner []common.Address) (event.Subscription, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _RewardLocker.contract.WatchLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(RewardLockerOwnershipTransferred)
				if err := _RewardLocker.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseOwnershipTransferred is a log parse operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_RewardLocker *RewardLockerFilterer) ParseOwnershipTransferred(log types.Log) (*RewardLockerOwnershipTransferred, error) {
	event := new(RewardLockerOwnershipTransferred)
	if err := _RewardLocker.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// RewardLockerRewardContractAddedIterator is returned from FilterRewardContractAdded and is used to iterate over the raw logs and unpacked data for RewardContractAdded events raised by the RewardLocker contract.
type RewardLockerRewardContractAddedIterator struct {
	Event *RewardLockerRewardContractAdded // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *RewardLockerRewardContractAddedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(RewardLockerRewardContractAdded)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(RewardLockerRewardContractAdded)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *RewardLockerRewardContractAddedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *RewardLockerRewardContractAddedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// RewardLockerRewardContractAdded represents a RewardContractAdded event raised by the RewardLocker contract.
type RewardLockerRewardContractAdded struct {
	RewardContract common.Address
	Token          common.Address
	IsAdded        bool
	Raw            types.Log // Blockchain specific contextual infos
}

// FilterRewardContractAdded is a free log retrieval operation binding the contract event 0x88a8c998079a07d6a1e59a32ce0c359a00e4c94ce7a6068350a9574e7e0f993d.
//
// Solidity: event RewardContractAdded(address indexed rewardContract, address indexed token, bool isAdded)
func (_RewardLocker *RewardLockerFilterer) FilterRewardContractAdded(opts *bind.FilterOpts, rewardContract []common.Address, token []common.Address) (*RewardLockerRewardContractAddedIterator, error) {

	var rewardContractRule []interface{}
	for _, rewardContractItem := range rewardContract {
		rewardContractRule = append(rewardContractRule, rewardContractItem)
	}
	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}

	logs, sub, err := _RewardLocker.contract.FilterLogs(opts, "RewardContractAdded", rewardContractRule, tokenRule)
	if err != nil {
		return nil, err
	}
	return &RewardLockerRewardContractAddedIterator{contract: _RewardLocker.contract, event: "RewardContractAdded", logs: logs, sub: sub}, nil
}

// WatchRewardContractAdded is a free log subscription operation binding the contract event 0x88a8c998079a07d6a1e59a32ce0c359a00e4c94ce7a6068350a9574e7e0f993d.
//
// Solidity: event RewardContractAdded(address indexed rewardContract, address indexed token, bool isAdded)
func (_RewardLocker *RewardLockerFilterer) WatchRewardContractAdded(opts *bind.WatchOpts, sink chan<- *RewardLockerRewardContractAdded, rewardContract []common.Address, token []common.Address) (event.Subscription, error) {

	var rewardContractRule []interface{}
	for _, rewardContractItem := range rewardContract {
		rewardContractRule = append(rewardContractRule, rewardContractItem)
	}
	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}

	logs, sub, err := _RewardLocker.contract.WatchLogs(opts, "RewardContractAdded", rewardContractRule, tokenRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(RewardLockerRewardContractAdded)
				if err := _RewardLocker.contract.UnpackLog(event, "RewardContractAdded", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseRewardContractAdded is a log parse operation binding the contract event 0x88a8c998079a07d6a1e59a32ce0c359a00e4c94ce7a6068350a9574e7e0f993d.
//
// Solidity: event RewardContractAdded(address indexed rewardContract, address indexed token, bool isAdded)
func (_RewardLocker *RewardLockerFilterer) ParseRewardContractAdded(log types.Log) (*RewardLockerRewardContractAdded, error) {
	event := new(RewardLockerRewardContractAdded)
	if err := _RewardLocker.contract.UnpackLog(event, "RewardContractAdded", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// RewardLockerSetVestingDurationIterator is returned from FilterSetVestingDuration and is used to iterate over the raw logs and unpacked data for SetVestingDuration events raised by the RewardLocker contract.
type RewardLockerSetVestingDurationIterator struct {
	Event *RewardLockerSetVestingDuration // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *RewardLockerSetVestingDurationIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(RewardLockerSetVestingDuration)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(RewardLockerSetVestingDuration)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *RewardLockerSetVestingDurationIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *RewardLockerSetVestingDurationIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// RewardLockerSetVestingDuration represents a SetVestingDuration event raised by the RewardLocker contract.
type RewardLockerSetVestingDuration struct {
	Token           common.Address
	VestingDuration uint64
	Raw             types.Log // Blockchain specific contextual infos
}

// FilterSetVestingDuration is a free log retrieval operation binding the contract event 0x8604b95f1c6f11de3cf58583f6524c5b1aaa150f2391ec1544bb059d75177236.
//
// Solidity: event SetVestingDuration(address indexed token, uint64 vestingDuration)
func (_RewardLocker *RewardLockerFilterer) FilterSetVestingDuration(opts *bind.FilterOpts, token []common.Address) (*RewardLockerSetVestingDurationIterator, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}

	logs, sub, err := _RewardLocker.contract.FilterLogs(opts, "SetVestingDuration", tokenRule)
	if err != nil {
		return nil, err
	}
	return &RewardLockerSetVestingDurationIterator{contract: _RewardLocker.contract, event: "SetVestingDuration", logs: logs, sub: sub}, nil
}

// WatchSetVestingDuration is a free log subscription operation binding the contract event 0x8604b95f1c6f11de3cf58583f6524c5b1aaa150f2391ec1544bb059d75177236.
//
// Solidity: event SetVestingDuration(address indexed token, uint64 vestingDuration)
func (_RewardLocker *RewardLockerFilterer) WatchSetVestingDuration(opts *bind.WatchOpts, sink chan<- *RewardLockerSetVestingDuration, token []common.Address) (event.Subscription, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}

	logs, sub, err := _RewardLocker.contract.WatchLogs(opts, "SetVestingDuration", tokenRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(RewardLockerSetVestingDuration)
				if err := _RewardLocker.contract.UnpackLog(event, "SetVestingDuration", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseSetVestingDuration is a log parse operation binding the contract event 0x8604b95f1c6f11de3cf58583f6524c5b1aaa150f2391ec1544bb059d75177236.
//
// Solidity: event SetVestingDuration(address indexed token, uint64 vestingDuration)
func (_RewardLocker *RewardLockerFilterer) ParseSetVestingDuration(log types.Log) (*RewardLockerSetVestingDuration, error) {
	event := new(RewardLockerSetVestingDuration)
	if err := _RewardLocker.contract.UnpackLog(event, "SetVestingDuration", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// RewardLockerUpdateMaxContractSizeIterator is returned from FilterUpdateMaxContractSize and is used to iterate over the raw logs and unpacked data for UpdateMaxContractSize events raised by the RewardLocker contract.
type RewardLockerUpdateMaxContractSizeIterator struct {
	Event *RewardLockerUpdateMaxContractSize // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *RewardLockerUpdateMaxContractSizeIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(RewardLockerUpdateMaxContractSize)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(RewardLockerUpdateMaxContractSize)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *RewardLockerUpdateMaxContractSizeIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *RewardLockerUpdateMaxContractSizeIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// RewardLockerUpdateMaxContractSize represents a UpdateMaxContractSize event raised by the RewardLocker contract.
type RewardLockerUpdateMaxContractSize struct {
	Size *big.Int
	Raw  types.Log // Blockchain specific contextual infos
}

// FilterUpdateMaxContractSize is a free log retrieval operation binding the contract event 0x8bdf9f5fcc8fec86d3107d9475d243a2d0259d5d7d58ace9671d049b53827efd.
//
// Solidity: event UpdateMaxContractSize(uint256 size)
func (_RewardLocker *RewardLockerFilterer) FilterUpdateMaxContractSize(opts *bind.FilterOpts) (*RewardLockerUpdateMaxContractSizeIterator, error) {

	logs, sub, err := _RewardLocker.contract.FilterLogs(opts, "UpdateMaxContractSize")
	if err != nil {
		return nil, err
	}
	return &RewardLockerUpdateMaxContractSizeIterator{contract: _RewardLocker.contract, event: "UpdateMaxContractSize", logs: logs, sub: sub}, nil
}

// WatchUpdateMaxContractSize is a free log subscription operation binding the contract event 0x8bdf9f5fcc8fec86d3107d9475d243a2d0259d5d7d58ace9671d049b53827efd.
//
// Solidity: event UpdateMaxContractSize(uint256 size)
func (_RewardLocker *RewardLockerFilterer) WatchUpdateMaxContractSize(opts *bind.WatchOpts, sink chan<- *RewardLockerUpdateMaxContractSize) (event.Subscription, error) {

	logs, sub, err := _RewardLocker.contract.WatchLogs(opts, "UpdateMaxContractSize")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(RewardLockerUpdateMaxContractSize)
				if err := _RewardLocker.contract.UnpackLog(event, "UpdateMaxContractSize", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseUpdateMaxContractSize is a log parse operation binding the contract event 0x8bdf9f5fcc8fec86d3107d9475d243a2d0259d5d7d58ace9671d049b53827efd.
//
// Solidity: event UpdateMaxContractSize(uint256 size)
func (_RewardLocker *RewardLockerFilterer) ParseUpdateMaxContractSize(log types.Log) (*RewardLockerUpdateMaxContractSize, error) {
	event := new(RewardLockerUpdateMaxContractSize)
	if err := _RewardLocker.contract.UnpackLog(event, "UpdateMaxContractSize", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// RewardLockerVestIterator is returned from FilterVest and is used to iterate over the raw logs and unpacked data for Vest events raised by the RewardLocker contract.
type RewardLockerVestIterator struct {
	Event *RewardLockerVest // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *RewardLockerVestIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(RewardLockerVest)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(RewardLockerVest)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *RewardLockerVestIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *RewardLockerVestIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// RewardLockerVest represents a Vest event raised by the RewardLocker contract.
type RewardLockerVest struct {
	Token        common.Address
	TotalVesting *big.Int
	Raw          types.Log // Blockchain specific contextual infos
}

// FilterVest is a free log retrieval operation binding the contract event 0xd4a50953e9ae2104f507446be8391c79b33e1e86e626473e34bb79eb5fea1f3e.
//
// Solidity: event Vest(address indexed token, uint256 totalVesting)
func (_RewardLocker *RewardLockerFilterer) FilterVest(opts *bind.FilterOpts, token []common.Address) (*RewardLockerVestIterator, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}

	logs, sub, err := _RewardLocker.contract.FilterLogs(opts, "Vest", tokenRule)
	if err != nil {
		return nil, err
	}
	return &RewardLockerVestIterator{contract: _RewardLocker.contract, event: "Vest", logs: logs, sub: sub}, nil
}

// WatchVest is a free log subscription operation binding the contract event 0xd4a50953e9ae2104f507446be8391c79b33e1e86e626473e34bb79eb5fea1f3e.
//
// Solidity: event Vest(address indexed token, uint256 totalVesting)
func (_RewardLocker *RewardLockerFilterer) WatchVest(opts *bind.WatchOpts, sink chan<- *RewardLockerVest, token []common.Address) (event.Subscription, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}

	logs, sub, err := _RewardLocker.contract.WatchLogs(opts, "Vest", tokenRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(RewardLockerVest)
				if err := _RewardLocker.contract.UnpackLog(event, "Vest", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseVest is a log parse operation binding the contract event 0xd4a50953e9ae2104f507446be8391c79b33e1e86e626473e34bb79eb5fea1f3e.
//
// Solidity: event Vest(address indexed token, uint256 totalVesting)
func (_RewardLocker *RewardLockerFilterer) ParseVest(log types.Log) (*RewardLockerVest, error) {
	event := new(RewardLockerVest)
	if err := _RewardLocker.contract.UnpackLog(event, "Vest", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// RewardLockerVestedIterator is returned from FilterVested and is used to iterate over the raw logs and unpacked data for Vested events raised by the RewardLocker contract.
type RewardLockerVestedIterator struct {
	Event *RewardLockerVested // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *RewardLockerVestedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(RewardLockerVested)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(RewardLockerVested)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *RewardLockerVestedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *RewardLockerVestedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// RewardLockerVested represents a Vested event raised by the RewardLocker contract.
type RewardLockerVested struct {
	Token          common.Address
	Beneficiary    common.Address
	VestedQuantity *big.Int
	Index          *big.Int
	Raw            types.Log // Blockchain specific contextual infos
}

// FilterVested is a free log retrieval operation binding the contract event 0x6d06f0a463d80b43fe6cd0b79c61bb2790cfe898790e69828f25e6e12886e178.
//
// Solidity: event Vested(address indexed token, address indexed beneficiary, uint256 vestedQuantity, uint256 index)
func (_RewardLocker *RewardLockerFilterer) FilterVested(opts *bind.FilterOpts, token []common.Address, beneficiary []common.Address) (*RewardLockerVestedIterator, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var beneficiaryRule []interface{}
	for _, beneficiaryItem := range beneficiary {
		beneficiaryRule = append(beneficiaryRule, beneficiaryItem)
	}

	logs, sub, err := _RewardLocker.contract.FilterLogs(opts, "Vested", tokenRule, beneficiaryRule)
	if err != nil {
		return nil, err
	}
	return &RewardLockerVestedIterator{contract: _RewardLocker.contract, event: "Vested", logs: logs, sub: sub}, nil
}

// WatchVested is a free log subscription operation binding the contract event 0x6d06f0a463d80b43fe6cd0b79c61bb2790cfe898790e69828f25e6e12886e178.
//
// Solidity: event Vested(address indexed token, address indexed beneficiary, uint256 vestedQuantity, uint256 index)
func (_RewardLocker *RewardLockerFilterer) WatchVested(opts *bind.WatchOpts, sink chan<- *RewardLockerVested, token []common.Address, beneficiary []common.Address) (event.Subscription, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var beneficiaryRule []interface{}
	for _, beneficiaryItem := range beneficiary {
		beneficiaryRule = append(beneficiaryRule, beneficiaryItem)
	}

	logs, sub, err := _RewardLocker.contract.WatchLogs(opts, "Vested", tokenRule, beneficiaryRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(RewardLockerVested)
				if err := _RewardLocker.contract.UnpackLog(event, "Vested", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseVested is a log parse operation binding the contract event 0x6d06f0a463d80b43fe6cd0b79c61bb2790cfe898790e69828f25e6e12886e178.
//
// Solidity: event Vested(address indexed token, address indexed beneficiary, uint256 vestedQuantity, uint256 index)
func (_RewardLocker *RewardLockerFilterer) ParseVested(log types.Log) (*RewardLockerVested, error) {
	event := new(RewardLockerVested)
	if err := _RewardLocker.contract.UnpackLog(event, "Vested", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// RewardLockerVestingEntryCreatedIterator is returned from FilterVestingEntryCreated and is used to iterate over the raw logs and unpacked data for VestingEntryCreated events raised by the RewardLocker contract.
type RewardLockerVestingEntryCreatedIterator struct {
	Event *RewardLockerVestingEntryCreated // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *RewardLockerVestingEntryCreatedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(RewardLockerVestingEntryCreated)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(RewardLockerVestingEntryCreated)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *RewardLockerVestingEntryCreatedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *RewardLockerVestingEntryCreatedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// RewardLockerVestingEntryCreated represents a VestingEntryCreated event raised by the RewardLocker contract.
type RewardLockerVestingEntryCreated struct {
	Token       common.Address
	Beneficiary common.Address
	StartBlock  *big.Int
	EndBlock    *big.Int
	Quantity    *big.Int
	Index       *big.Int
	Raw         types.Log // Blockchain specific contextual infos
}

// FilterVestingEntryCreated is a free log retrieval operation binding the contract event 0xfb1fd0fee690638acf30008a00d7fc669e970dd6fa8912488ee11171986edabb.
//
// Solidity: event VestingEntryCreated(address indexed token, address indexed beneficiary, uint256 startBlock, uint256 endBlock, uint256 quantity, uint256 index)
func (_RewardLocker *RewardLockerFilterer) FilterVestingEntryCreated(opts *bind.FilterOpts, token []common.Address, beneficiary []common.Address) (*RewardLockerVestingEntryCreatedIterator, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var beneficiaryRule []interface{}
	for _, beneficiaryItem := range beneficiary {
		beneficiaryRule = append(beneficiaryRule, beneficiaryItem)
	}

	logs, sub, err := _RewardLocker.contract.FilterLogs(opts, "VestingEntryCreated", tokenRule, beneficiaryRule)
	if err != nil {
		return nil, err
	}
	return &RewardLockerVestingEntryCreatedIterator{contract: _RewardLocker.contract, event: "VestingEntryCreated", logs: logs, sub: sub}, nil
}

// WatchVestingEntryCreated is a free log subscription operation binding the contract event 0xfb1fd0fee690638acf30008a00d7fc669e970dd6fa8912488ee11171986edabb.
//
// Solidity: event VestingEntryCreated(address indexed token, address indexed beneficiary, uint256 startBlock, uint256 endBlock, uint256 quantity, uint256 index)
func (_RewardLocker *RewardLockerFilterer) WatchVestingEntryCreated(opts *bind.WatchOpts, sink chan<- *RewardLockerVestingEntryCreated, token []common.Address, beneficiary []common.Address) (event.Subscription, error) {

	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var beneficiaryRule []interface{}
	for _, beneficiaryItem := range beneficiary {
		beneficiaryRule = append(beneficiaryRule, beneficiaryItem)
	}

	logs, sub, err := _RewardLocker.contract.WatchLogs(opts, "VestingEntryCreated", tokenRule, beneficiaryRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(RewardLockerVestingEntryCreated)
				if err := _RewardLocker.contract.UnpackLog(event, "VestingEntryCreated", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseVestingEntryCreated is a log parse operation binding the contract event 0xfb1fd0fee690638acf30008a00d7fc669e970dd6fa8912488ee11171986edabb.
//
// Solidity: event VestingEntryCreated(address indexed token, address indexed beneficiary, uint256 startBlock, uint256 endBlock, uint256 quantity, uint256 index)
func (_RewardLocker *RewardLockerFilterer) ParseVestingEntryCreated(log types.Log) (*RewardLockerVestingEntryCreated, error) {
	event := new(RewardLockerVestingEntryCreated)
	if err := _RewardLocker.contract.UnpackLog(event, "VestingEntryCreated", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// RewardLockerVestingEntryQueuedIterator is returned from FilterVestingEntryQueued and is used to iterate over the raw logs and unpacked data for VestingEntryQueued events raised by the RewardLocker contract.
type RewardLockerVestingEntryQueuedIterator struct {
	Event *RewardLockerVestingEntryQueued // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *RewardLockerVestingEntryQueuedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(RewardLockerVestingEntryQueued)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(RewardLockerVestingEntryQueued)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *RewardLockerVestingEntryQueuedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *RewardLockerVestingEntryQueuedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// RewardLockerVestingEntryQueued represents a VestingEntryQueued event raised by the RewardLocker contract.
type RewardLockerVestingEntryQueued struct {
	Index       *big.Int
	Token       common.Address
	Beneficiary common.Address
	Quantity    *big.Int
	Raw         types.Log // Blockchain specific contextual infos
}

// FilterVestingEntryQueued is a free log retrieval operation binding the contract event 0xa6fd3a57929c9152d86fa5f83c8478f1af480353a0aef0cacc3240d63b570767.
//
// Solidity: event VestingEntryQueued(uint256 indexed index, address indexed token, address indexed beneficiary, uint256 quantity)
func (_RewardLocker *RewardLockerFilterer) FilterVestingEntryQueued(opts *bind.FilterOpts, index []*big.Int, token []common.Address, beneficiary []common.Address) (*RewardLockerVestingEntryQueuedIterator, error) {

	var indexRule []interface{}
	for _, indexItem := range index {
		indexRule = append(indexRule, indexItem)
	}
	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var beneficiaryRule []interface{}
	for _, beneficiaryItem := range beneficiary {
		beneficiaryRule = append(beneficiaryRule, beneficiaryItem)
	}

	logs, sub, err := _RewardLocker.contract.FilterLogs(opts, "VestingEntryQueued", indexRule, tokenRule, beneficiaryRule)
	if err != nil {
		return nil, err
	}
	return &RewardLockerVestingEntryQueuedIterator{contract: _RewardLocker.contract, event: "VestingEntryQueued", logs: logs, sub: sub}, nil
}

// WatchVestingEntryQueued is a free log subscription operation binding the contract event 0xa6fd3a57929c9152d86fa5f83c8478f1af480353a0aef0cacc3240d63b570767.
//
// Solidity: event VestingEntryQueued(uint256 indexed index, address indexed token, address indexed beneficiary, uint256 quantity)
func (_RewardLocker *RewardLockerFilterer) WatchVestingEntryQueued(opts *bind.WatchOpts, sink chan<- *RewardLockerVestingEntryQueued, index []*big.Int, token []common.Address, beneficiary []common.Address) (event.Subscription, error) {

	var indexRule []interface{}
	for _, indexItem := range index {
		indexRule = append(indexRule, indexItem)
	}
	var tokenRule []interface{}
	for _, tokenItem := range token {
		tokenRule = append(tokenRule, tokenItem)
	}
	var beneficiaryRule []interface{}
	for _, beneficiaryItem := range beneficiary {
		beneficiaryRule = append(beneficiaryRule, beneficiaryItem)
	}

	logs, sub, err := _RewardLocker.contract.WatchLogs(opts, "VestingEntryQueued", indexRule, tokenRule, beneficiaryRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(RewardLockerVestingEntryQueued)
				if err := _RewardLocker.contract.UnpackLog(event, "VestingEntryQueued", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseVestingEntryQueued is a log parse operation binding the contract event 0xa6fd3a57929c9152d86fa5f83c8478f1af480353a0aef0cacc3240d63b570767.
//
// Solidity: event VestingEntryQueued(uint256 indexed index, address indexed token, address indexed beneficiary, uint256 quantity)
func (_RewardLocker *RewardLockerFilterer) ParseVestingEntryQueued(log types.Log) (*RewardLockerVestingEntryQueued, error) {
	event := new(RewardLockerVestingEntryQueued)
	if err := _RewardLocker.contract.UnpackLog(event, "VestingEntryQueued", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}
